#include "Common.h"
#define TRACTOR "Peral_AS32A"
#define SPEEDTAXI 2

private ["_plane", "_pos", "_tractor", "_eleObj", "_dest", "_dir", "_grp"];

_nim = param [0, ObjNull];
_plane = param [1, ObjNull];

if (isNull _nim) exitWith {"No Nimitz" call BIS_fnc_log};
if (isNull _plane) exitWith {"No plane object" call BIS_fnc_log;};

_pos = getPos _plane;
_pos = CIRCLEPOS2(_pos, 270, 11);
_pos = [_pos select 0, _pos select 1, 7];

sleep 2;
_tractor = TRACTOR createVehicle _pos;
_tractor setPosASL _pos;
_tractor setDir (getDir _plane);
/*createVehicleCrew _tractor;*/
_grp = createGroup west;
 "FUTARM_YELLOW_MT" createUnit [[0,0,0], _grp];
(units _grp select 0) moveInDriver _tractor;
_tractor engineOn true;

[_tractor] call LESH_towing_fnc_checkTowable;
[_tractor, _plane] call LESH_towing_fnc_tow;

_eleObj = _pos nearestObject "JDG_carrier_ele_3";

[_eleObj, 1] call TTT_fnc_elevator;
waitUntil {_eleObj animationPhase "ani_ElevBarB" < -0.9};

player sideChat "Pushing plane on elevator";

_dest = _eleObj modelToWorld (_eleObj selectionPosition "E3Bottom");

_dest = [_dest select 0, _dest select 1, 7.5];
while {_tractor distance _dest > 9} do {
    _v = [getPosASL _tractor, _dest] call BIS_fnc_vectorFromXToY;
    _tractor setVelocity [
	  (_v select 0) * SPEEDTAXI,
	  (_v select 1) * SPEEDTAXI,
	  0
    ];
    sleep 0.05;
};

[_tractor] call LESH_towing_fnc_detach;
sleep 0.1;
_plane setVelocity [0,0,0];

// reverse tractor
_v = [getPosASL _tractor, _pos] call BIS_fnc_vectorFromXToY;
while {_tractor distance _pos > 5} do {
  _tractor setVelocity [
    (_v select 0) * SPEEDTAXI,
    (_v select 1) * SPEEDTAXI,
    0
  ];
};

[_eleObj, 0] call TTT_fnc_elevator;

_pos = getPos _plane;
_pos = CIRCLEPOS2(_pos, 270, 11);
_pos = [_pos select 0, _pos select 1, 17.5];

deleteVehicle _tractor;

_tractor = TRACTOR createVehicle _pos;
_tractor setPosASL _pos;
_tractor setDir (getDir _plane);
/*createVehicleCrew _tractor;*/
grp = createGroup west;
 "FUTARM_YELLOW_MT" createUnit [[0,0,0], _grp];
(units _grp select 0) moveInDriver _tractor;
_tractor engineOn true;

waitUntil {_eleObj animationPhase "ani_ElevBarT" < 0.1};

[_tractor] call LESH_towing_fnc_checkTowable;
[_tractor, _plane] call LESH_towing_fnc_tow;

_nimspots = _nim getVariable "nimspots";
_dest = _nimspots modelToWorld(_nimspots selectionPosition "C3");
_dir = [_tractor, _dest] call BIS_fnc_dirTo;
_tractor setDir _dir;
while {_tractor distance _dest > 1} do {
    _v = [getPosASL _tractor, _dest] call BIS_fnc_vectorFromXToY;
    _tractor setVelocity [
	  (_v select 0) * SPEEDTAXI,
	  (_v select 1) * SPEEDTAXI,
	  0
    ];
    sleep 0.05;
};

_dest = CIRCLEPOS2(_dest, getDir _nim, 10);
_dest = [_dest select 0, _dest select 1, 17.5];
_dir = [_tractor, _dest] call BIS_fnc_dirTo;
_tractor setDir _dir;
while {_tractor distance _dest > 1} do {
    _v = [getPosASL _tractor, _dest] call BIS_fnc_vectorFromXToY;
    _tractor setVelocity [
	  (_v select 0) * SPEEDTAXI,
	  (_v select 1) * SPEEDTAXI,
	  0
    ];
    sleep 0.05;
};

[_tractor] call LESH_towing_fnc_detach;
sleep 0.1;
_plane setVelocity [0,0,0];
_plane animate ["l_wingfold",0];
_plane animate ["r_wingfold",0];

_dest = _nimspots modelToWorld(_nimspots selectionPosition "C1");

_dest = [_dest select 0, _dest select 1, 17.5];
_dir = [_tractor, _dest] call BIS_fnc_dirTo;
_tractor setDir _dir;
while {_tractor distance _dest > 45} do {
    _v = [getPosASL _tractor, _dest] call BIS_fnc_vectorFromXToY;
    _tractor setVelocity [
	  (_v select 0) * SPEEDTAXI,
	  (_v select 1) * SPEEDTAXI,
	  0
    ];
    sleep 0.05;
};

[_nim, _plane, 3] execVM "functions\fn_planeStart.sqf";